ticketsystem/urls.py
from django.contrib import admin
from django.urls import path, include, re_path
from django.conf import settings

from ticketsystem.modules.tickets.views import *

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", TicketList.as_view(), name="ticket_list"),
    path("ticket/<int:pk>/", TicketDetail.as_view(), name="ticket_detail"),
    path("ticket/note/create/<int:pk>/", NoteCreate.as_view(), name="note_create"),
    path("accounts/", include("django.contrib.auth.urls")),
]

if settings.DEBUG:
    import debug_toolbar
    from django.conf.urls.static import static
    from django.contrib.staticfiles.urls import staticfiles_urlpatterns

    # Serve static and media files from development server
    urlpatterns += staticfiles_urlpatterns()
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

    urlpatterns += [
        re_path(r"^__debug__/", include(debug_toolbar.urls)),
    ]

ticketsystem/modules/accounts/models/account.py
from django.contrib.auth.base_user import AbstractBaseUser
from django.contrib.auth.models import PermissionsMixin
from django.core.mail import send_mail
from django.db import models
from django.utils import timezone
from django.utils.translation import gettext_lazy as _

from ticketsystem.modules.accounts.managers import AccountManager


class Account(AbstractBaseUser, PermissionsMixin):
    email = models.EmailField(
        _("Email adres"),
        unique=True,
        error_messages={
            "unique": _("Er bestaat al een medewerker met dit email adres."),
        },
    )
    first_name = models.CharField(_("Voornaam"), max_length=150, blank=True)
    last_name = models.CharField(_("Achternaam"), max_length=150, blank=True)

    is_staff = models.BooleanField(
        _("Medewerker status"),
        default=False,
        help_text=_("Geeft aan of deze medewerker kan inloggen op het admin paneel."),
    )
    is_active = models.BooleanField(
        _("Actief"),
        default=True,
        help_text=_(
            "Geeft aan of deze medewerker moet worden gezien als actief. Deselecteer dit inplaats van het account verwijderen."
        ),
    )
    date_joined = models.DateTimeField(_("Toevoeg datum"), default=timezone.now)

    objects = AccountManager()

    EMAIL_FIELD = "email"
    USERNAME_FIELD = "email"

    class Meta:
        verbose_name = _("Medewerker")
        verbose_name_plural = _("Medewerkers")

    def clean(self):
        super().clean()
        self.email = self.__class__.objects.normalize_email(self.email)

    def get_full_name(self):
        """
        Return the first_name plus the last_name, with a space in between.
        """
        full_name = "%s %s" % (self.first_name, self.last_name)
        return full_name.strip()

    def get_short_name(self):
        """Return the short name for the user."""
        return self.first_name

    def email_user(self, subject, message, from_email=None, **kwargs):
        """Send an email to this user."""
        send_mail(subject, message, from_email, [self.email], **kwargs)

ticketsystem/modules/contact_persons/models/contact_person.py
from django.db import models
from phonenumber_field.modelfields import PhoneNumberField
from django.utils.translation import gettext_lazy as _


class ContactPerson(models.Model):
    contact_person_name = models.CharField(
        _("Naam"),
        max_length=50,
        null=True,
        blank=True,
    )
    company = models.CharField(_("Bedrijf"), max_length=255, null=True, blank=True)
    email = models.EmailField(_("Email adres"))
    phone_number = PhoneNumberField(_("Telefoon nummer"), null=True, blank=True)

    def __str__(self):
        if self.contact_person_name and self.company:
            return f"{self.contact_person_name} - {self.company}"
        elif self.contact_person_name:
            return f"{self.contact_person_name} - {self.email}"

        return self.email

    class Meta:
        verbose_name = _("Contact persoon")
        verbose_name_plural = _("Contact personen")

ticketsystem/modules/tickets/models/category.py
from django.db import models
from django.utils.translation import gettext_lazy as _


class Category(models.Model):
    category = models.CharField(_("Categorie"), max_length=50)

    class Meta:
        verbose_name = "Categorie"
        verbose_name_plural = "Categorieën"

    def __str__(self):
        return self.category

ticketsystem/modules/tickets/models/note.py
from django.db import models
from django.utils.translation import gettext_lazy as _


class Note(models.Model):
    employee = models.ForeignKey(
        "accounts.Account",
        on_delete=models.SET_NULL,
        verbose_name="Medewerker",
        null=True,
        blank=False,
    )
    ticket = models.ForeignKey(
        "tickets.Ticket",
        on_delete=models.CASCADE,
        verbose_name="Ticket",
        related_name="notes",
    )
    note = models.TextField(_("Notitie"))
    dt_added = models.DateTimeField(_("Toevoeg datum"), auto_now_add=True)

    def __str__(self):
        return f"{self.employee.get_full_name()} - {self.ticket.title}"

ticketsystem/modules/tickets/models/ticket.py
from django.db import models
from django.utils.translation import gettext_lazy as _


class Ticket(models.Model):
    PRIORITIES = (
        (0, "Laag"),
        (1, "Normaal"),
        (2, "Hoog"),
    )

    STATUSES = (
        (0, "Wachtend"),
        (1, "Geaccepteerd"),
        (2, "Afgewezen"),
        (3, "Wordt aan gewerkt"),
        (4, "Gearchiveerd"),
    )

    title = models.CharField(_("Titel"), max_length=100)
    description = models.TextField(_("Beschrijving"))
    category = models.ForeignKey(
        "tickets.Category",
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
        related_name="tickets",
        verbose_name="Categorie",
    )
    assignee = models.ForeignKey(
        "accounts.Account",
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
        related_name="tickets",
        verbose_name="Medewerker",
    )
    contact_person = models.ForeignKey(
        "contact_persons.ContactPerson",
        on_delete=models.CASCADE,
        related_name="tickets",
        verbose_name="Contact persoon",
    )
    dt_added = models.DateTimeField(_("Toevoeg datum"), auto_now_add=True)
    priority = models.IntegerField(_("Prioriteit"), choices=PRIORITIES, default=1)
    status = models.IntegerField(_("Status"), choices=STATUSES, default=0)

    def __str__(self):
        return f"{self.id:04d}"

    class Meta:
        verbose_name = "Ticket"
        verbose_name_plural = "Tickets"

ticketsystem/modules/accounts/forms.py
from django.contrib.auth.forms import UserCreationForm, UserChangeForm

from ticketsystem.modules.accounts.models import Account


class AccountCreationForm(UserCreationForm):

    class Meta:
        model = Account
        fields = ('email',)


class AccountChangeForm(UserChangeForm):

    class Meta:
        model = Account
        fields = ('email',)

ticketsystem/modules/tickets/forms.py
from django import forms

from ticketsystem.modules.tickets.models import Note


class NoteCreateForm(forms.ModelForm):
    # note = forms.CharField(label="Notitie")
    class Meta:
        model = Note
        fields = ["note", "employee", "ticket"]

ticketsystem/modules/tickets/views/note_create.py
from django.views import generic
from django.http import Http404

from ticketsystem.modules.tickets.models import Note
from ticketsystem.modules.tickets.forms import NoteCreateForm


# Deze view wordt gebruikt op de ticket detail pagina om notities toe te voegen
class NoteCreate(generic.CreateView):
    model = Note
    form_class = NoteCreateForm

    def get(self, request, *args, **kwargs):
        raise Http404

    def post(self, request, *args, **kwargs):
        raise ValueError(request.data)

ticketsystem/modules/tickets/views/ticket_detail.py
from django.views import generic

from ticketsystem.modules.tickets.models import Ticket


class TicketDetail(generic.DetailView):
    template_name = "tickets/detail.html"

    def get_queryset(self):
        return Ticket.objects.all()

ticketsystem/modules/tickets/views/ticket_list.py
from django.views import generic
from django.db.models import Q

from ticketsystem.modules.tickets.models import Ticket


class TicketList(generic.ListView):
    template_name = "tickets/base.html"

    # Er wordt hier gefilterd op 3 van de 5 statusen. namelijk op: Wachtend, Geaccepteerd en Wordt aan gewerkt
    def get_queryset(self):
        filter = Q(Q(status=0) | Q(status=1) | Q(status=3))
        return Ticket.objects.all().filter(filter)

ticketsystem/templates/base.html
<!-- base.html -->
<!DOCTYPE html>
<html>
    <head>
        {% load static %}
        {% block stylesheets %}{% endblock %}
        <link rel="stylesheet" type="text/css" href="{% static 'css/main.css' %}">
        {% block style %}<style type="text/css"></style>{% endblock %}
        <meta charset="utf-8" />
        <meta name="viewport"
              content="width=device-width, initial-scale=1, shrink-to-fit=no"/>
        <link rel="stylesheet"
              href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
              integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"
              crossorigin="anonymous"/>
        <title>
            {% block title %}{% endblock %}
        </title>
    </head>
    <body>
        {% block header %}
            <header class="p-3 border-bottom">
                <div style="max-width: 1280px" class="m-auto py-1">
                    <div class="d-inline-flex w-100 justify-content-between">
                        <a href="/">
                            <img src="/media/images/mmc_logo.png"
                                 alt="MMC logo"
                                 style="max-width: 100px;"/>
                        </a>
                        <ul class="nav nav-pills d-flex align-items-center">
                            {% if request.user.is_staff %}
                                <li class="nav-item">
                                    <a href="/admin/" class="nav-link">Admin paneel</a>
                                </li>
                            {% endif %}
                            <li class="nav-item">
                                <a href="/accounts/logout/" class="nav-link">Loguit</a>
                            </li>
                        </ul>
                    </div>
                </div>
            </header>
        {% endblock %}
        {% block content %}{% endblock %}
        <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
    </body>
</html>

ticketsystem/templates/tickets/base.html
{% extends "base.html" %}
{% block title %}Tickets{% endblock %}
{% block content %}
    <main class="m-auto pt-4" style="max-width: 1280px">
        <h1>Ticket tabel</h1>
        <table class="table table-bordered">
            <thead>
                <tr>
                    <th scope="col" style="width: 5%">#</th>
                    <th scope="col">Titel</th>
                    <th scope="col">Medewerker</th>
                    <th scope="col">Contact persoon</th>
                    <th scope="col">Prioriteit</th>
                    <th scope="col">Status</th>
                </tr>
            </thead>
            <tbody>
                {% for ticket in ticket_list %}
                    <tr>
                        <th scope="row">{{ ticket.id }}</th>
                        <td>
                            <a href="/ticket/{{ ticket.id }}/">{{ ticket.title }}</a>
                        </td>
                        <td>{{ ticket.assignee.first_name }} {{ ticket.assignee.last_name }}</td>
                        <td>{{ ticket.contact_person }}</td>
                        <td>{{ ticket.get_priority_display }}</td>
                        <td>{{ ticket.get_status_display }}</td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    </main>
{% endblock %}

ticketsystem/templates/tickets/detail.html
{% extends "base.html" %}
{% block content %}
    <main class="m-auto pt-4" style="max-width: 1280px">
        <div class="d-flex gap-3 justify-content-between mb-5 flex-column-reverse flex-lg-row">
            <section class="col-12 col-lg-8">
                <h2 class="">Ticket #{{ ticket }} - {{ ticket.title }}</h2>
                <h4 class="">Description:</h4>
                <p style="word-wrap:break-word;">{{ ticket.description }}</p>
                <h4 class="">Notities:</h4>
                <div>
                    {% for note in ticket.notes.all %}
                        <div class="d-flex flex-column pb-2">
                            <p class="m-0" style="font-size: 15px">{{ note.employee.get_full_name }}</p>
                            <small class="m-0" style="font-size: 13px">{{ note.dt_added }}</small>
                        </div>
                        <p style="word-wrap:break-word;">{{ note.note }}</p>
                        <hr>
                    {% endfor %}
                </div>
                <form method="post">
                    {% csrf_token %}
                    <textarea name="note"
                              placeholder="Notite..."
                              class="w-100"
                              style="min-height: 10rem;"></textarea>
                    <button type="submit"
                            class="text-white rounded"
                            style="background-color: #00D32A;
                                   border-width: 0;
                                   font-size: 14px;
                                   font-weight: bold;
                                   padding: 10px 20px;">
                        Voeg notitie toe
                    </button>
                </form>
            </section>
            <section class="col-12 col-lg-4">
                <div class="d-grid gap-1 p-3" style="background-color: #F4F7FB;">
                    <div class="row m-0">
                        <p class="col-6 m-0 p-0">Medewerker:</p>
                        <p class="col-6 m-0 p-0">{{ ticket.assignee.get_full_name }}</p>
                    </div>
                    <div class="row m-0">
                        <p class="col-6 m-0 p-0">Contact persoon:</p>
                        <p class="col-6 m-0 p-0">{{ ticket.contact_person }}</p>
                    </div>
                    <div class="row m-0">
                        <p class="col-6 m-0 p-0">Email:</p>
                        <p class="col-6 m-0 p-0" style="word-wrap: break-word;">{{ ticket.contact_person.email }}</p>
                    </div>
                    {% if ticket.contact_person.phone_number %}
                        <div class="row m-0">
                            <p class="col-6 m-0 p-0">Nummer:</p>
                            <p class="col-6 m-0 p-0" style="word-wrap: break-word;">{{ ticket.contact_person.phone_number }}</p>
                        </div>
                    {% endif %}
                    <hr>
                    <div class="row m-0">
                        <p class="col-6 m-0 p-0">Toevoeg datum:</p>
                        <p class="col-6 m-0 p-0">{{ ticket.dt_added }}</p>
                    </div>
                    <div class="row m-0">
                        <p class="col-6 m-0 p-0">Categorie:</p>
                        <p class="col-6 m-0 p-0">{{ ticket.category }}</p>
                    </div>
                </div>
            </section>
        </div>
    </main>
{% endblock %}